<?php
namespace Opencart\Catalog\Model\Extension\Trustpay4\Payment;

class TrustpayBT extends \Opencart\System\Engine\Model {
	public function getMethod($address) {
		$this->load->language('extension/trustpay4/payment/trustpay_bt');

		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "zone_to_geo_zone WHERE geo_zone_id = '" . (int)$this->config->get('payment_trustpay_bt_geo_zone_id') . "' AND country_id = '" . (int)$address['country_id'] . "' AND (zone_id = '" . (int)$address['zone_id'] . "' OR zone_id = '0')");
                
                $total = $this->cart->getTotal();

		if (!empty($this->session->data['vouchers'])) {
			$amounts = array_column($this->session->data['vouchers'], 'amount');
		} else {
			$amounts = [];
		}

		$total = $total + array_sum($amounts);
                
                if ($this->config->get('payment_trustpay_bt_total') > $total) {
                        $status = false;
		} elseif (!$this->config->get('payment_trustpay_bt_geo_zone_id')) {
			$status = true;
		} elseif ($query->num_rows) {
			$status = true;
		} else {
			$status = false;
		}

		$currencies = array(
			'CZK',
			'EUR'
		);

		if (!in_array(strtoupper($this->session->data['currency']), $currencies)) {
			$status = false;
		}

		$method_data = array();

		if ($status) {
			$method_data = array(
				'code'       => 'trustpay_bt',
				'title'      => $this->language->get('text_title'),
				'terms'      => '',
				'sort_order' => $this->config->get('payment_trustpay_bt_sort_order')
			);
		}

		return $method_data;
	}
}
